using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting.Proxies;
using System.Text.RegularExpressions;

namespace WindowsApplication1
{
    /// <summary>
    /// WFlbNNullObject񋟂܂B
    /// vLV̊{@\񋟂RealProxyp܂B
    /// </summary>
    /// <typeparam name="T">
    /// NullObjectΏۂ̌^w肵܂BFpublicȃftHgRXgN^LMarshalByRefObject^̃NXł邱ƁB
    /// </typeparam>
    public class NullProxy<T> : RealProxy where T : MarshalByRefObject ,new()
    {
        /// <summary>
        /// WFlbNSingleton񋟂邽߂̃RNVB
        /// KxRŎW܂ł̊Ԃ̎アQƂێ܂B
        /// </summary>
        private static readonly Dictionary<Type, WeakReference> dicNullObject = new Dictionary<Type, WeakReference>();

        /// <summary>
        /// rbNIuWFNg
        /// </summary>
        static readonly object syncObj = new object();

        /// <summary>
        /// RXgN^
        /// </summary>
        public NullProxy() : base(typeof(T)) { 
        }

        /// <summary>
        /// \bhĂяoɊ荞łȂɂ܂B
        /// \bhɖ߂lꍇAl^Ȃ珉lԂ܂B
        /// Qƌ^̏ꍇAۃNXуC^[tFCXłnullԂ܂B
        /// łȂ΁ASystem.MarshalByRefObject̔hNX̏ꍇA
        /// NullProxy<T>ʂĐNullObjectԂ܂B
        /// 
        /// \bḧɂāAoutp[^refp[^łꍇA
        /// ̃p[^System.MarshalByRefObject̔hNXłꍇA
        /// ̃p[^ɑ΂āANullProxy<T>ʂĐNullObjectԂ܂B
        /// </summary>
        /// <param name="msg">bZ[WʐMIuWFNg</param>
        /// <returns>ReturnMessageIuWFNg</returns>
        public override IMessage Invoke(IMessage msg)
        {
            IMethodCallMessage req = msg as IMethodCallMessage;
            object response = null;

            //\bh̃^f[^擾
            MethodInfo methodInfo = ((MethodInfo)req.MethodBase);

            //Outp[^z
            ArrayList  outList = new ArrayList();

            //\bh̊ep[^
            foreach (ParameterInfo paramInfo in methodInfo.GetParameters())
            {
                if (paramInfo.ParameterType.IsByRef){
                    //out/refp[^̏ꍇ
                    //o̎Qƌ^̌^ɑ΂ANullObjectƂēK؂ȃCX^X擾

                    //K\ByRefӖ ɂ"&" ^̖O菜
                    string typeString = paramInfo.ParameterType.ToString();
                    Regex regex = new Regex("&$");
                    typeString = regex.Replace(typeString, string.Empty);
                    
                    outList.Add(GetResponceInstance(Type.GetType(typeString)));          
                }
            }
            
            //߂ľ^ɑ΂ANullObjectƂēK؂ȃCX^X擾
            response = GetResponceInstance(methodInfo.ReturnType);

            //^[bZ[W
            return new ReturnMessage(response,outList.ToArray(),outList.Count, req.LogicalCallContext, req);
        }

        /// <summary>
        /// Ώۂ̌^ɂāANullObjectƂĕԂK؂ȃCX^X擾܂B
        /// </summary>
        /// <param name="t">Ώۂ̌^</param>
        /// <returns>NullObjectƂĕԂK؂ȃCX^X擾܂B</returns>
        private object GetResponceInstance(Type t){
            object response = null;

            if (t.IsValueType)
            {
                //l^̏ꍇ
                if (t != typeof(void))
                {
                    //߂lꍇ
                    response = Activator.CreateInstance(t);
                }
            }else{
                //Qƌ^̏ꍇ
                
                if (t != typeof(void))
                {
                    //voidł͂Ȃꍇ
                    
                    //ۃNXA邢̓C^[tFCXłnullԂ
                    if (t.IsAbstract || t.IsInterface) { return null; }

                    if (t.IsMarshalByRef)
                    {
                        //QƓnŃ}[VOꍇ

                        //NullProxy<>̌^擾
                        Type genericType = typeof(NullProxy<>);
                        //NullProxyɕKvȃWFlbN^𐶐
                        Type constructGenericType = genericType.MakeGenericType(new Type[] { t });
                        //vĂNullProxy<>CX^X𐶐
                        object nullproxy = Activator.CreateInstance(constructGenericType);

                        //tNV𗘗pNullObject𐶐
                        response = nullproxy.GetType().InvokeMember("GetInstance", BindingFlags.InvokeMethod, null, response, null);
                    }
                }
            }        
            return response;
        }

        /// <summary>
        /// Ώۂ̌^NullObjectCX^X擾܂B
        /// e^NullObjectCX^X́AKxRŎW܂ł̊SingletonŒ񋟂܂B
        /// </summary>
        /// <returns>Ώۂ̌^NullObjectCX^X</returns>
        public static T GetInstance()
        {
            lock (syncObj)
            {
                NullProxy<T> result = null;
                Type t = typeof(T);

                //KxRΏۂ̂܂܎QƂ܂B
                WeakReference w = dicNullObject.ContainsKey(t) ? dicNullObject[t] : null;

                if (w != null){
                    result = w.Target as NullProxy<T>;
                }
                
                if (result == null)
                {
                    result = new NullProxy<T>();
                    
                    dicNullObject[t] = new WeakReference(result,true);
                }

                // NullObjectΏۂ̌^̓߃vLVԂ܂B
                return (T)result.GetTransparentProxy();
            }
        }
    }
}
